
#include "misc.h"


// variable length for stopwords isn't worth the trouble
// we'd waste 1 bucket / stopword, and save 4 bytes / unique word
struct Word
{
	u32 key;
	u32 is_stopword : 1;

	u32 last : 31;
	u32 buckets : 8;
	u32 first : 24;
};

typedef Word Item;


#define M 42

struct STnode {
     Item b[M];
     int m;
     int k;
};

typedef struct STnode* link;


/*template<class Item>*/ class ExtHashTbl
{
public:
	void init();

	Item* insert(Item& item);
	Item* search(u32 v);
	void tree_out();

	// we've been relocated. fixup all internal pointers by adding delta
	void ExtHashTbl::rebase(long delta);

        int D;
private:


	link NEW();

	int d;
	link *dir;

	u32 bits(u32 hashkey, u32 startpos, u32 length);
	u32 bits2(u32 hashkey, u32 startpos, u32 length);
	u32 bits3(u32 hashkey, u32 startpos, u32 length);
	Item* search_in_db(link h, u32 v);
	void insertDir(link t, int k);
	Item* split(link h, int added);
	Item* insert_in_db(link h, Item item);

};

