//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "running.h"
#include "idx.h"

//#include <shlobj.h>

#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SHDocVw_OCX"
#pragma link "cdiroutl"
#pragma resource "*.dfm"
Tmainform *mainform;
//---------------------------------------------------------------------------
__fastcall Tmainform::Tmainform(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------



// ---------------------------------------------------------------------------

void __fastcall Tmainform::idxbtnClick(TObject *Sender)
{
    // check if valid dir-name and start scan
    AnsiString Dir = Edit1->Text;
    if (DirectoryExists( Dir ))
    {
        scanform->StartScan( Dir );
        Edit2->SetFocus();
    }
    else
        Application->MessageBoxA("Please enter a valid pathname !","Invalid Path",MB_OK);
}
//---------------------------------------------------------------------------

void search()
{
    // start search
    search( mainform->Edit2->Text.c_str() );

    // get results
    int counter = 0;
    const char* filename, *context;
    int freq=123;
    AnsiString conv;

    mainform->ListView1->Items->Clear();    // clear last search result

    while (get_next_search_result(filename, freq, 0) != -1)
    {
        if(!freq)	// surrounding text wasn't found-
        		// it's probably a collision.
        	continue;
        // add result to list
        TListItem* Line = mainform->ListView1->Items->Add();
        if(freq < 0)	// overflowed, -freq is minimum
        	conv.sprintf("> %d", -freq);
        else
        	conv.sprintf("%d", freq);
	// dont assign directly
         Line->Caption = conv;
        conv = filename;
        Line->SubItems->Add( conv );

        counter++;
    }
mainform->ListView1->Update();
    conv.printf("%d matches found !",counter);
    mainform->StatusBar1->Panels->Items[0]->Text = conv;
    mainform->StatusBar1->Refresh();

counter = 0;

    while (get_next_search_result(filename, freq, &context) != -1)
    {

        if(!freq)	// surrounding text wasn't found-
        		// it's probably a collision.
        	continue;
mainform->ListView1->Update();
                //mainform->ListView1->UpdateItems(counter,counter);

//if(counter%20 == 0 && counter < 30) mainform->ListView1->Refresh();
//if(counter == 20) mainform->ListView1->Items->BeginUpdate();
        conv = context;
mainform->ListView1->Items->Item[counter]->SubItems->Add(conv);
        counter++;
    }
//   mainform->ListView1->Items->EndUpdate();



    }

//---------------------------------------------------------------------------

void __fastcall Tmainform::BitBtn2Click(TObject *Sender)
{
    search();
}
//---------------------------------------------------------------------------


void __fastcall Tmainform::Edit2KeyPress(TObject *Sender, char &Key)
{
    if( Key == '\r' )
        search();
}
//---------------------------------------------------------------------------

void __fastcall Tmainform::Edit1KeyPress(TObject *Sender, char &Key)
{
    if( Key == '\r' )
        idxbtnClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall Tmainform::ListView1DblClick(TObject *Sender)
{
	if(ListView1->Selected)
	{
	    AnsiString file = ListView1->Selected->SubItems->Strings[0];

	    if ( FileExists( file ))
	        ShellExecute( mainform->Handle, "open", file.c_str(), NULL, NULL, SW_SHOWNORMAL);
	}
}
//---------------------------------------------------------------------------




void __fastcall Tmainform::FormShow(TObject *Sender)
{
    Edit1->SetFocus();

    if(!read_idx())
    {
	    AnsiString tmp;
            tmp.sprintf("Search in: %s (%d files)", cur_path, num_files);
	    mainform->StatusBar1->Panels->Items[1]->Text = tmp;
               BitBtn2->Enabled = true;
    }
    else
    	    mainform->StatusBar1->Panels->Items[1]->Text = "No index loaded";
}
//---------------------------------------------------------------------------

static int sorttype;	// index into subitems
static int down = -1;

void __fastcall Tmainform::ListView1ColumnClick(TObject *Sender,
      TListColumn *Column)
{
//MessageBox(0, "agg", "blabb", 0);
if(Column->Caption == "Freq")
sorttype = -1;
else if(Column->Caption == "Filename")
sorttype = 0;
else
return;

down = -down;
ListView1->AlphaSort();
}
//---------------------------------------------------------------------------

void __fastcall Tmainform::ListView1Compare(TObject *Sender,
      TListItem *Item1, TListItem *Item2, int Data, int &Compare)
{
String s1, s2;
if(sorttype == -1)
{
s1 = Item1->Caption;
s2 = Item2->Caption;
if(s1[1] == '>') s1[1] = ' ';	// starts at 1, dammit
if(s2[1] == '>') s2[1] = ' ';
Compare = (s1.ToInt() - s2.ToInt()) * down;
}
else
{
s1 = Item1->SubItems->Strings[sorttype];
s2 = Item2->SubItems->Strings[sorttype];
Compare = s1.AnsiCompare(s2) * down;
}
}
//---------------------------------------------------------------------------

