//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "running.h"
#include "main.h"
#include "idx.h"
#include "time.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CGAUGES"
#pragma resource "*.dfm"
Tscanform *scanform;
//---------------------------------------------------------------------------
__fastcall Tscanform::Tscanform(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

#define output scanform->Memo1->Lines->Add

//---------------------------------------------------------------------------

static double start_time;

void __fastcall Tscanform::StartScan(const AnsiString Dir)
{

CGauge1->Progress = 0;

    scanform->Caption = "Scanning ...";
    scanform->stop->Caption = "&Abort";
    scanform->Memo1->Lines->Clear();

    start_time = get_time();

    if (create_idx( Dir.c_str() ) != -1)          // start scan
        scanform->Memo1->Lines->Add("Scanning ...");
    else
        scanform->Memo1->Lines->Add("ERROR: Can not initialize indexscan !");

    Timer1->Enabled = true;   // start timer for status update
    ShowModal();              // display form an return when index ready or failed

}


//---------------------------------------------------------------------------

void __fastcall Tscanform::Timer1Timer(TObject *Sender)
{
    AnsiString out;
    static int times;
    static float avg_sum, max;

static int ticks;

        const float MB = 1048576.f;

	double elapsed = get_time() - start_time;
        int ds = (int)elapsed;
    int min = ds / 60;
    int sec = ds % 60;

IdxStatus status = idx_status();

    if(status != IS_ACTIVE)
    {
        if ( status == IS_SUCCEEDED )
        {
            output( "Index complete ! :-)" );
            output( "----------------------------------------------" );
            output( "Statistics:");
            out.sprintf("  Time for Scan: %d:%02d",min,sec);
            output( out );
            out.sprintf("  total files: %d ", num_files);
            output( out );
            out.sprintf("  average throughput: %.2f MB/s", (total_bytes_read / elapsed) / MB);
            output( out );
            out.sprintf("  maximum throughput: %.2f MB/s", max/MB);
            output( out );

            out.sprintf(" unique words: %d; text processed: %d; total words: %d ", (int)unique_words, (int)total_text, (int)total_words);
            output( out );
        }
        else if(status == IS_FAILED)
            output( "SCAN FAILED !" );

        Timer1->Enabled = false;
        stop->Caption = "&Close";

        // HACK: update text one last time
        ticks = 0;
    }


        // HACK: this may be called before thread does gen_file_list
        int progress = (total_bytes > 0)? (int)((float)total_bytes_read / total_bytes * 100) : 0;
        CGauge1->Progress = progress;

        const float tp = read_throughput;
        if ( tp>max ) max = tp;
        avg_sum += tp;
        times++;



//only update every 200 ms, so we can see text ;)
//no time for a real filter.
if(ticks++%10 == 0)
{
        out.sprintf("%.2f MB/s", tp/MB);
        Label1->Caption = out;
        out.sprintf("%.2f MB", total_bytes_read/MB);
        Label2->Caption = out;
        out.sprintf("%.2f MB", total_bytes/MB);
        Label3->Caption = out;

        out.sprintf("%d:%02d ",min,sec );
        Label4->Caption = out;
 }
}
//---------------------------------------------------------------------------


void __fastcall Tscanform::stopClick(TObject *Sender)
{
	scanform->Close();

}
//---------------------------------------------------------------------------

void __fastcall Tscanform::FormClose(TObject *Sender, TCloseAction &Action)
{
IdxStatus status = idx_status();
   // if running -> stop scan
    if ( status == IS_ACTIVE )
    {
        if (cancel_idx() != -1)
            output( "Scan aborted!" );
        else
            output( "Cancel failed!");
        while((status = idx_status()) == IS_ACTIVE)
        	Sleep(10);
    }

    if(status == IS_SUCCEEDED)
    {
	    mainform->StatusBar1->Panels->Items[1]->Text = "Reading index...";
        if(read_idx() == 0)
    	{
    	    AnsiString tmp;
            tmp.sprintf("Search in: %s (%d files)", cur_path, num_files);
	    mainform->StatusBar1->Panels->Items[1]->Text = tmp;
	     mainform->BitBtn2->Enabled = true;
	}
        else
        {
	        Application->MessageBoxA("Error reading index file !","Ohoh !",MB_OK);
                mainform->StatusBar1->Panels->Items[1]->Text = "No index loaded";
	        mainform->BitBtn2->Enabled = false;
        }
    }
    else
    {
MessageBox(0,"indexing failed",0,0);
    }

	Action = caHide;
}
//---------------------------------------------------------------------------

